stages:
    - build
    - release

variables:
        DOCKER_HOST: tcp://docker:2375/
        DOCKER_DRIVER: overlay2
        DOCKER_TLS_CERTDIR: ""

.docker-template: &docker-template
    image: docker:latest
    before_script:
        - docker info
        - docker login --username $DOCKER_USERNAME --password $DOCKER_PASSWORD    
    services:
        - name: docker:dind
          entrypoint: ["env", "-u", "DOCKER_HOST"]
          command: ["dockerd-entrypoint.sh"]
    after_script:
        - docker logout

.docker-build-template: &docker-build-template
    <<: *docker-template
    stage: build
    rules:
        - if: $CI_COMMIT_TAG == null
    script:
        - docker build -t $DOCKER_REPOSITORY/$DOCKER_IMAGE:$BUILD_VERSION .
        - docker push $DOCKER_REPOSITORY/$DOCKER_IMAGE:$BUILD_VERSION

.docker-release-template: &docker-release-template
    <<: *docker-template
    stage: release
    rules:
        - if: $CI_COMMIT_TAG
    script:
        - docker pull $DOCKER_REPOSITORY/$DOCKER_IMAGE:$BUILD_VERSION
        - docker image tag $DOCKER_REPOSITORY/$DOCKER_IMAGE:$BUILD_VERSION $DOCKER_REPOSITORY/$DOCKER_IMAGE:$CI_COMMIT_TAG
        - docker image tag $DOCKER_REPOSITORY/$DOCKER_IMAGE:$CI_COMMIT_TAG $DOCKER_REPOSITORY/$DOCKER_IMAGE:latest
        - docker push $DOCKER_REPOSITORY/$DOCKER_IMAGE:$CI_COMMIT_TAG


development:build:
    <<: *docker-build-template
    variables:
        DOCKER_IMAGE: semver
        BUILD_VERSION: $CI_COMMIT_SHORT_SHA
    
production:release:
    <<: *docker-release-template
    variables:
        DOCKER_IMAGE: semver
        BUILD_VERSION: $CI_COMMIT_SHORT_SHA